Index: pjproject/trunk/pjlib-util/include/pjlib-util/crc32.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/crc32.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/crc32.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjlib-util/include/pjlib-util/hmac_md5.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/hmac_md5.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/hmac_md5.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjlib-util/include/pjlib-util/hmac_sha1.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/hmac_sha1.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/hmac_sha1.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjlib-util/include/pjlib-util/md5.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/md5.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/md5.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjlib-util/include/pjlib-util/scanner.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/scanner.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/scanner.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjlib-util/include/pjlib-util/scanner_cis_bitwise.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/scanner_cis_bitwise.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/scanner_cis_bitwise.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjlib-util/include/pjlib-util/scanner_cis_uint.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/scanner_cis_uint.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/scanner_cis_uint.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjlib-util/include/pjlib-util/sha1.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/sha1.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/sha1.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjlib-util/include/pjlib-util/stun_simple.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/stun_simple.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/stun_simple.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjlib-util/include/pjlib-util/xml.h
===================================================================
--- pjproject/trunk/pjlib-util/include/pjlib-util/xml.h	(revision 1373)
+++ pjproject/trunk/pjlib-util/include/pjlib-util/xml.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/include/pjnath/ice_session.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/ice_session.h	(revision 1373)
+++ pjproject/trunk/pjnath/include/pjnath/ice_session.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/include/pjnath/stun_auth.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/stun_auth.h	(revision 1373)
+++ pjproject/trunk/pjnath/include/pjnath/stun_auth.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/include/pjnath/stun_config.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/stun_config.h	(revision 1373)
+++ pjproject/trunk/pjnath/include/pjnath/stun_config.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/include/pjnath/stun_msg.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/stun_msg.h	(revision 1373)
+++ pjproject/trunk/pjnath/include/pjnath/stun_msg.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/include/pjnath/stun_session.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/stun_session.h	(revision 1373)
+++ pjproject/trunk/pjnath/include/pjnath/stun_session.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/include/pjnath/stun_transaction.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/stun_transaction.h	(revision 1373)
+++ pjproject/trunk/pjnath/include/pjnath/stun_transaction.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjnath/ice_session.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/ice_session.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjnath/ice_session.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjnath/stun_auth.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_auth.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjnath/stun_auth.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjnath/stun_msg.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjnath/stun_msg_dump.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_msg_dump.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjnath/stun_msg_dump.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjnath/stun_session.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjnath/stun_transaction.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_transaction.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjnath/stun_transaction.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjstun-client/client_main.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-client/client_main.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjstun-client/client_main.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/bind_usage.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/bind_usage.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/bind_usage.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/main.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/main.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/main.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/server.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/server.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/server.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/server.h
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/server.h	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/server.h	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/turn_usage.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/turn_usage.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/turn_usage.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/usage.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/usage.c	(revision 1373)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/usage.c	(revision 1374)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2003-2005 Benny Prijono <benny@prijono.org>
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
  *
  * This program is free software; you can redistribute it and/or modify